//Mid-game golf hud
hud.add(function(v,player)

	//Sanity checks
	if gametype ~= GT_GOLF then return end
	hud.disable("lives")
	if (player.mo == nil) or (not player.valid) then return end
	
	//Listing score strings in an array
	local parScoring = {"Triple bogey +", "Triple bogey", "Double bogey", "Bogey", "Par", "Birdie", "Eagle", "Albatross", "Condor", "Condor -"}
	
	//Creates putt counter and course par indicator.
	if gametype == GT_GOLF then
		hud.disable("rings")
		v.puttext = v.cachePatch("whytho")
		v.contmenu = v.cachePatch("contmenu")
		v.par = v.cachePatch("crsepar")
		v.newRings = v.cachePatch("nosrslywhy")
		v.holeIcon = v.cachePatch("holico")
		if player.mo then
			//Putts and par
			v.draw(hudinfo[HUD_RINGS].x, hudinfo[HUD_RINGS].y+16, v.puttext, hudinfo[HUD_RINGS].f|V_PERPLAYER)
			v.drawNum(80, hudinfo[HUD_RINGS].y+16, player.putts, hudinfo[HUD_RINGSNUM].f|V_PERPLAYER)
			v.draw(hudinfo[HUD_RINGS].x, hudinfo[HUD_RINGS].y+32, v.par, hudinfo[HUD_RINGS].f|V_PERPLAYER)
			v.drawNum(80, hudinfo[HUD_RINGS].y+32, player.arrangedpar[player.holeCount], hudinfo[HUD_RINGSNUM].f|V_PERPLAYER)
			
			//Current hole X course total
			v.drawScaled((hudinfo[HUD_LIVES].x-4)*FRACUNIT, (hudinfo[HUD_LIVES].y-1)*FRACUNIT, (FRACUNIT/4)*3, v.holeIcon, V_SNAPTOBOTTOM)
			v.drawString(35, 180, "hole", V_SNAPTOBOTTOM, "small")
			v.drawString((41*FRACUNIT)-FRACUNIT/6, 188*FRACUNIT, "/", V_SNAPTOBOTTOM, "small-fixed")
			v.drawString(35, 188, player.holeCount, V_SNAPTOBOTTOM, "small")
			v.drawString(51, 188, player.courseHoles+1, V_SNAPTOBOTTOM, "small-right")
			
			//A menu for easily checking the golf controls
			//goes away after 1 minute, but can be reopened.
			v.drawScaled((player.menuint)*FRACUNIT+(FRACUNIT/2), 35*FRACUNIT, FRACUNIT/2, v.contmenu, V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER)
			
			
			//...and down here we do all this garbage just so RINGS doesn't blink. god why.
			v.draw(hudinfo[HUD_RINGS].x, hudinfo[HUD_RINGS].y, v.newRings, hudinfo[HUD_RINGS].f)
			v.drawNum(80, hudinfo[HUD_RINGSNUM].y, player.rings, hudinfo[HUD_RINGSNUM].f)
		end
	end
	
	//Putt bar patch initialization
	v.puttbar = v.cachePatch("puttbar")
	v.powbar = v.cachePatch("powbar")
	v.difsel = v.cachePatch("difsel")
	local barcolor = mapheaderinfo[gamemap].barchargecolor
	if not barcolor then barcolor = ColorOpposite(player.mo.color) end
	local chargecolor = mapheaderinfo[gamemap].stagebarcolor
	if not chargecolor then chargecolor = player.mo.color end
	
	//Drawing the putt bar when ready to putt.
	if (player.puttReady) or (player.blinktimer and leveltime%2 and player.speed) then
		for i=1,player.pwrBarPos do
			if i <= 80 then
				v.drawScaled((117+i)*FRACUNIT, 150*FRACUNIT, FRACUNIT/3, v.powbar, V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, barcolor))
			else
				//Preventing an overflowing bar
				v.drawScaled((117+80)*FRACUNIT, 150*FRACUNIT, FRACUNIT/3, v.powbar, V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, barcolor))
			end
		end
		v.drawStretched(117*FRACUNIT, 150*FRACUNIT, FRACUNIT/3*2, FRACUNIT/4, v.puttbar, V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, chargecolor))
		--Speed selection goes here
		v.drawString(117, 133, "charge", V_SNAPTOBOTTOM, "small")
		v.drawString(117, 138, "speed", V_SNAPTOBOTTOM, "small")
		v.drawScaled(117*FRACUNIT, (143*FRACUNIT)+FRACUNIT/2, FRACUNIT/2, v.difsel, V_SNAPTOBOTTOM)
		if player.puttspd > 0 then
			v.drawString((122*FRACUNIT)+FRACUNIT/2, (143*FRACUNIT)+FRACUNIT/2, player.puttspd, V_SNAPTOBOTTOM, "small-fixed")
			--v.drawNum(126, 143, player.puttspd, V_SNAPTOBOTTOM)
			v.drawScaled((131*FRACUNIT)+FRACUNIT/2, (143*FRACUNIT)+FRACUNIT/2, FRACUNIT/2, v.difsel, V_FLIP | V_SNAPTOBOTTOM)
		else --manual charge HUD changes, pushing the right difsel further right
			v.drawString((122*FRACUNIT)+FRACUNIT/2, (143*FRACUNIT)+FRACUNIT/2, "manual", V_SNAPTOBOTTOM, "small-fixed")
			v.drawScaled((151*FRACUNIT)+FRACUNIT/2, (143*FRACUNIT)+FRACUNIT/2, FRACUNIT/2, v.difsel, V_FLIP | V_SNAPTOBOTTOM)
		end
		
	end
	
	//Course end text goes here	
	if player.textCrawl and player.textCrawl < 550 and player.stopCrawl == false then
		v.drawString(player.textCrawl, 70, player.crawlText, player.scoreColor, "center")
		v.drawString(player.textCrawl, 80, "+" .. player.crawlScore, player.scoreColor, "center")
	end

end,"game")
